<template>
  <div class="w100 scoring">
    <div v-if="!hasAccess">
      <div class="alert-container">
        <ob-alert
          text="Ошибка доступа"
          :hide-close-button="true"
          theme="danger"
        />
      </div>
    </div>
    <ob-modal
      ref="modal-error"
      :title="'Ошибка на сервере'"
      :isShowControls="true"
      :isReadOnly="true"
    />
    <ob-modal
      ref="modal-success"
      :title="'Данные сохранены'"
      :isShowControls="true"
      :isReadOnly="true"
    />
    <ob-modal
      ref="modal-activate"
      :title="'Активировать версию?'"
      :isShowControls="true"
      :okText="'Да'"
      @submit="activate"
    />

    <div v-if="hasAccess">
      <div class="header">
        <ob-func-panel
          :columns="[]"
          :show-column-filter="false"
          :show-search="false"
          :show-group="false"
          :show-sort="false"
        >
          <template slot="buttons">
            <div class="scoring-no-border">
              <ob-select
                :items="models"
                v-model="selectedModel"
                display-exp="title"
                value-exp="uuid"
                :disabled="false"
                label="МОДЕЛИ НЕЙРОННОЙ СЕТИ"
              ></ob-select>
            </div>
          </template>
        </ob-func-panel>
      </div>
      <two-section
        :left-caption="title"
        right-caption=""
        :class="'scoring'"
      >
        <template slot="left">

          <ob-table
            v-if="selectedModel == 1"
            :items="versionsCarrier"
            :columns="columns"
            @select="showVersion"
          />
          <ob-table
            v-if="selectedModel == 2"
            :items="versionsClient"
            :columns="columns"
            @select="showVersion"
          />
        </template>

        <template slot="right">
          <div
            v-if="!selectedVersion"
            class="scoring__no-version"
          >
            Версия не выбрана
          </div>
          <ob-tabs v-if="selectedVersion" class="scoring__tabs" :key="selectedVersion.uuid">
            <ObTabsPane title="ОТЧЕТ ПО ВЕРСИИ" :is-selected="true">

              <div class="scoring__form">
                <template slot="title">Отчет по Версии скоринга {{ selectedVersion.type === 'CARRIER'?  'поставщиков' : 'клиентов' }} {{ selectedVersion.version }}</template>
                <div class="scoring__info">
                  <div class="scoring__details">
                    <div class="row">
                      <p>Роль - {{ selectedVersion.type === 'CARRIER'?  'перевозчик' : 'клиент' }}</p>
                    </div>
                    <div class="row">
                      <p>Период действия: с {{selectedVersion.activatedAt}}</p>
                    </div>
                    <div class="row">
                      <p>Параметры модели</p>
                    </div>
                  </div>
                  <div class="scoring__status">
                    <p>Статус: {{selectedVersion.isActive ? 'Активна' : 'Не активна'}}</p>
                    <div v-if="!selectedVersion.isActive">
                      <ob-button
                        :class="scoring__status__button"
                        @click="showActivateModal"
                        label="Активировать"
                        type="flat"
                      />
                    </div>
                  </div>

                </div>

                <ob-form
                  :isOnlySubmit="true"
                  @submit="submit"
                  :isSubmitDisabled="selectedVersion.description === old_description"
                  :formData="selectedVersion"
                  :formModel="{}"
                >
                  <div class="row">
                    <ob-text-area
                      :label="`Краткое описание`"
                      :placeholder="`Краткое описание`"
                      property="description"
                      v-model="selectedVersion.description"
                    ></ob-text-area>
                  </div>
                  <div class="row row__grid">

                    <div class="scoring__column">
                      <ob-text-area
                        disabled
                        :label="`Параметры модели НС`"
                        :placeholder="`Параметры модели НС`"
                        property="params"
                        v-model="selectedVersion.params"
                      ></ob-text-area>
                    </div>
                    <div class="scoring__column">
                      <ob-input
                        disabled
                        :label="`Оценка обученности НС`"
                        :placeholder="`Оценка обученности НС`"
                        property="loss_train"
                        v-model="selectedVersion.lossTrain"
                      ></ob-input>
                      <img v-if="selectedVersion.data" class="scoring__image" :src="'data:image/jpeg;base64,' + selectedVersion.data" alt="График обучения">
                    </div>
                  </div>
                </ob-form>
              </div>
            </ObTabsPane>

            <ObTabsPane title="ГРАФИК ОБУЧЕНИЯ" :is-selected="false">
              <div className="scoring__settings" v-if="!editSettings">
                <div class="scoring__form">
                  <div class="row">
                    <p>Тип обучения: {{ settings.periodicType === 'DAY' ? 'Ежедневное обучение' : 'Еженедельное обучение' }}</p>
                  </div>
                  <div class="row">
                    <p>Количество новых анкет для обучения: {{ settings.cardCount }}</p>
                  </div>
                </div>

                <ob-button
                  @click="toggleSettings"
                  label="Редактировать"
                  type="flat"
                />
              </div>
              <div v-if="editSettings" class="scoring__form">
                <ob-form
                  :formData="settings"
                  :isSubmitDisabled="!is_schedule_form_edited"
                  @submit="setSettings"
                  @cancel="cancelSettings"
                >
                  <template slot="title">Настройка графика переобучения системы</template>
                  <div class="row">
                    <ob-select
                      v-model="settings.periodicType"
                      :items="trainSelect"
                      display-exp="title"
                      value-exp="uuid"
                      :disabled="false"
                      label="Тип обучения"
                      placeholder="Тип обучения"
                    ></ob-select>
                  </div>
                  <div class="row">
                    <ob-input
                      :label="`Количество новых анкет для обучения`"
                      :placeholder="`Количество новых анкет для обучения`"
                      property="cardCount"
                      v-model="settings.cardCount"
                    ></ob-input>
                  </div>
                </ob-form>
              </div>
            </ObTabsPane>
          </ob-tabs>
        </template>
      </two-section>
    </div>

  </div>
</template>

<script>
import moment from 'moment'

import TwoSection from 'common-components/src/obComponents/obTwoPanels';
import ObFuncPanel from 'common-components/src/obComponents/obFuncPanel';
import ObSelect from 'common-components/src/obComponents/obSelect';
import ObTable from 'common-components/src/obComponents/obTable';
import ObTabs from 'common-components/src/obComponents/obTabs';
import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane';
import ObForm from 'common-components/src/obComponents/obForm';
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextArea from 'common-components/src/obComponents/obTextarea'
import ObButton from 'common-components/src/obComponents/obButton'
import ObModal from 'common-components/src/obComponents/obModal';
import ObAlert from 'common-components/src/obComponents/obAlert';

import api from '@/api';

import {GET_USER_INFO} from '@/store/modules/bonus_methodologies';

export default {
  name: 'scoring',
  components: {
    TwoSection,
    ObFuncPanel,
    ObSelect,
    ObTable,
    ObTabs,
    ObTabsPane,
    ObForm,
    ObInput,
    ObTextArea,
    ObButton,
    ObModal,
    ObAlert,
  },
  async created() {
    await this.$store.dispatch(GET_USER_INFO);
  },
  async mounted() {
    await this.getVersions();
    await this.getSettings();
  },
  methods: {
    async showVersion (row) {
      this.selectedVersion = row
      await this.getSingleVersion(row.uuid)
    },
    async getSingleVersion(uuid) {
      const version = await api.scoring.getSingleVersion(uuid);
      this.selectedVersion = {...version.data, activatedAt: version.data.activatedAt ? moment(version.data.activatedAt).format('DD.MM.YYYY') : '-'}
      this.old_description = version.data.description
      this.toggleTabs(1)
    },
    async getVersions() {
      try {
        const versions = await api.scoring.getVersions();
        const formatted = versions.data
          .map(v => ({
            ...v,
            version: v.version >= 0 ? v.version : 1,
            finishedAt: moment(v.finishedAt).format('DD.MM.YYYY'),
            activatedAt: v.activatedAt ? moment(v.activatedAt).format('DD.MM.YYYY') : '-',
            isActive: v.isActive ? 'Активна' : 'Не активна'
          }))

        this.versionsCarrier =  formatted
          .filter(v => v.type ==='CARRIER')

        this.versionsClient = formatted
          .filter(v => v.type ==='CLIENT')

      } catch (err) {
        console.error(err);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async getSettings() {
      try {
        const settings = await api.scoring.getSettings();
        this.settings = settings.data
        this.oldSettings = {...settings.data}
      } catch (err) {
        console.error(err);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    cancelSettings() {
      this.settings = {...this.oldSettings}
      this.toggleSettings()
    },
    async setSettings() {
      const notificationId = `${new Date().getTime()}save`;

      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });
        const data = {
          periodicType: this.settings.periodicType,
          cardCount: this.settings.cardCount,
        }
        const settings = await api.scoring.setSettings(data);
        this.settings = settings.data
        this.oldSettings = {...settings.data}
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        });

        this.$refs['modal-success'].open();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
        this.$refs['modal-error'].open();

      } finally {
        this.$notification({
          event: 'close',
          id: notificationId
        })
      }
    },
    async showActivateModal () {
      this.$refs['modal-activate'].open();
    },
    async activate () {
      this.$refs['modal-activate'].close();
      const version = await api.scoring.activateVersion(this.selectedVersion.uuid)
      this.selectedVersion = {...this.selectedVersion, activatedAt: moment(version.data.activatedAt).format('DD.MM.YYYY'), isActive: true}
      this.$refs['modal-success'].open();
      this.getVersions()
    },
    async submit () {
      const notificationId = `${new Date().getTime()}save`;

      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });
        await api.scoring.setSingleVersion(this.selectedVersion.uuid, {description: this.selectedVersion.description})
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        });
        this.$refs['modal-success'].open();

      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
        this.$refs['modal-error'].open();

      } finally {
        this.$notification({
          event: 'close',
          id: notificationId
        })
      }
    },
    toggleSettings () {
      this.editSettings = !this.editSettings
    },
    toggleTabs (tab) {
      this.tab = tab
    },
  },
  computed: {
    title: function () {
      return this.selectedModel == 1 ? 'ВЕРСИИ МОДЕЛИ РАСЧЕТА СКОРИНГА ПОСТАВЩИКОВ' : 'ВЕРСИИ МОДЕЛИ РАСЧЕТА СКОРИНГА КЛИЕНТОВ'
    },
    hasAccess() {
      const userRole = this.$store.getters.getUserRole;
      return (userRole === 'admin' || userRole === 'administrator')
    },
    pendingUserInfo() {
      return !this.$store.getters.getUserInfo;
    }
  },
  watch: {
      'settings.cardCount': function (newSettings, oldSettings) {
        if (oldSettings && oldSettings !== newSettings) {
          this.is_schedule_form_edited = true
        }
      },
      'settings.periodicType': function (newSettings, oldSettings) {
        if (oldSettings && oldSettings !== newSettings) {
          this.is_schedule_form_edited = true
        }
      },
  },
  data() {
    return {
      tab: 1,
      is_schedule_form_edited: false,
      old_description: '',
      trainSelect: [
        {
          uuid: 'DAY',
          title: 'Ежедневное обучение'
        },
        {
          uuid: 'WEEK',
          title: 'Еженедельное обучение'
        },
      ],
      timeSelect: [
        {
          uuid: '1',
          title: '00.00'
        },
        {
          uuid: '2',
          title: '00.01'
        },
      ],

      editSettings: false,
      selectedVersion: null,
      selectedModel: '1',
      settings: {},
      oldSettings: {},
      models: [
        {
          uuid: '1',
          title: 'Модель расчета скоринга поставщиков'
        },
        {
          uuid: '2',
          title: 'Модель расчета скоринга клиентов'
        }
      ],
      columns: [
        {
          title: 'Версия',
          key: 'version'
        },
        {
          title: 'Дата создания',
          key: 'finishedAt'
        },
        {
          title: 'Период действия',
          key: 'activatedAt'
        },
        {
          title: 'Статус',
          key: 'isActive'
        }
      ],
      versionsCarrier:[],
      versionsClient:[],
    };
  }
};
</script>
<style lang="scss">
  .w100 {
    width: 100%;
  }
  .scoring-no-border {
    align-self: center;

    .ob-selector__select {
      border: none;
    }
  }

  .scoring__tabs {
    padding: 10px 20px 0 20px;
  }

  .scoring__form {
    padding: 20px 0;

    .row {
      margin: 15px 0;

      &__grid {
        display: flex;
        justify-content: space-between;
      }
    }
  }

  .scoring__column {
    width: calc(50% - 10px);
  }
  .scoring table {
    width: 100%;
    min-width: 100%;
  }

  .scoring__no-version {
    font-size: 18px;
    line-height: 29px;
    color: #9DA0AC;
    letter-spacing: 0.4px;
    text-align: center;
    padding: 50px 20px;
  }

  .scoring__image {
    margin-top: 20px;
    max-width: 100%;
  }

  .scoring__info {
    display: flex;
    justify-content: space-between;
  }

  .scoring__status {
    text-align: right;
    button.ob-button-container.flat-type {
      padding: 0;
    }
  }
  .alert-container {
    margin-top: 20px;
    padding: 0 15px;
  }
</style>
